Skip to main content

A file upload component lets users select and manage files.

The native input file element is quite difficult to style and doesn't provide a drag-n-drop version.

The file upload component doesn't handle the actual file uploading process. It only handles the UI and the state of the file upload.

Loading...

Features

  • Supports a button to open the file dialog
  • Supports drag and drop to upload files
  • Set the maximum number of files that can be uploaded
  • Set the maximum size of the files that can be uploaded
  • Set the accepted file types

Installation

Install the file upload package:

npm install @zag-js/file-upload @zag-js/solid # or yarn add @zag-js/file-upload @zag-js/solid

Anatomy

To set up the file upload correctly, you'll need to understand its anatomy and how we name its parts.

Each part includes a data-part attribute to help identify them in the DOM.

Usage

Import the file upload package:

import * as fileUpload from "@zag-js/file-upload"

The file upload package exports two key functions:

  • machine - Behavior logic.
  • connect - Maps behavior to JSX props and event handlers.

Then use the framework integration helpers:

import * as fileUpload from "@zag-js/file-upload" import { normalizeProps, useMachine } from "@zag-js/solid" import { createUniqueId, createMemo, Index } from "solid-js" export function FileUpload() { const service = useMachine(fileUpload.machine, { id: createUniqueId(), }) const api = createMemo(() => fileUpload.connect(service, normalizeProps)) return ( <div {...api().getRootProps()}> <div {...api().getDropzoneProps()}> <input {...api().getHiddenInputProps()} /> <span>Drag your file(s) here</span> </div> <button {...api().getTriggerProps()}>Choose file(s)</button> <ul {...api().getItemGroupProps()}> <Index each={api().acceptedFiles}> {(file) => ( <li {...api().getItemProps({ file: file() })}> <div {...api().getItemNameProps({ file: file() })}> {file().name} </div> <button {...api().getItemDeleteTriggerProps({ file: file() })}> Delete </button> </li> )} </Index> </ul> </div> ) }

Setting the accepted file types

Use the accept attribute to set the accepted file types.

const service = useMachine(fileUpload.machine, { accept: "image/*", })

Alternatively, you can provide an object with a MIME type and an array of file extensions.

const service = useMachine(fileUpload.machine, { accept: { "image/png": [".png"], "text/html": [".html", ".htm"], }, })

Setting the maximum number of files

Use maxFiles to set how many files can be selected.

const service = useMachine(fileUpload.machine, { maxFiles: 5, })

Setting the minimum size per file

Use minFileSize to reject files smaller than a minimum size.

const service = useMachine(fileUpload.machine, { minFileSize: 1024, // 1KB })

Setting the maximum size per file

Use the maxFileSize attribute to set the maximum size per file that can be uploaded.

const service = useMachine(fileUpload.machine, { maxFileSize: 1024 * 1024 * 10, // 10MB })

Setting initial files

Use defaultAcceptedFiles to prefill the accepted files list.

const service = useMachine(fileUpload.machine, { defaultAcceptedFiles: [ new File(["hello"], "hello.txt", { type: "text/plain" }), ], })

Controlled files

Use acceptedFiles and onFileChange to control accepted files externally.

const service = useMachine(fileUpload.machine, { acceptedFiles, onFileChange(details) { setAcceptedFiles(details.acceptedFiles) }, })

Listening to file changes

When files are uploaded, the onFileChange callback is invoked with the details of the accepted and rejected files.

const service = useMachine(fileUpload.machine, { onFileChange(details) { // details => { acceptedFiles: File[], rejectedFiles: { file: File, errors: FileError[] }[] } console.log(details.acceptedFiles) console.log(details.rejectedFiles) }, })

Listening to accept and reject events

Use onFileAccept and onFileReject for separated success/failure flows.

const service = useMachine(fileUpload.machine, { onFileAccept(details) { console.log("Accepted:", details.files) }, onFileReject(details) { console.log("Rejected:", details.files) }, })

Usage within a form

To use file upload in a form, set name and render api.getHiddenInputProps().

const service = useMachine(fileUpload.machine, { name: "avatar", })
<input {...api.getHiddenInputProps()} />

Displaying image preview

To display a preview of the uploaded image, use the built-in FileReader API to read the file and set the src attribute of an image element.

const service = useMachine(fileUpload.machine, { onFileChange(details) { const reader = new FileReader() reader.onload = (event) => { const image = event.target.result // set the image as the src of an image element } reader.readAsDataURL(details.acceptedFiles[0]) }, })

Applying custom validation

To apply custom validation, set validate to a function that returns an array of error strings.

The returned array can contain any string as an error message. While zagjs supports default errors such as TOO_MANY_FILES, FILE_INVALID_TYPE, FILE_TOO_LARGE, or FILE_TOO_SMALL, you can return any string that represents your custom validation errors.

Return null if no validation errors are detected.

const service = useMachine(fileUpload.machine, { validate(file, details) { // Check if file size exceeds 10MB if (file.size > 1024 * 1024 * 10) { return ["FILE_TOO_LARGE"] } // details => { acceptedFiles, rejectedFiles } console.log(details.acceptedFiles.length) return null }, })

Apply multiple validation errors:

const service = useMachine(fileUpload.machine, { validate(file, details) { const errors = [] // Check file size if (file.size > 10 * 1024 * 1024) { errors.push("FILE_TOO_LARGE") // Default error enum } // Ensure file is a PDF if (!file.name.endsWith(".pdf")) { errors.push("ONLY_PDF_ALLOWED") // Custom error } // Custom check: Reject duplicate files const isDuplicate = details.acceptedFiles.some( (acceptedFile) => acceptedFile.name === file.name, ) if (isDuplicate) { errors.push("FILE_EXISTS") } return errors.length > 0 ? errors : null }, })

Disabling drag and drop

Set allowDrop to false to disable drag and drop.

const service = useMachine(fileUpload.machine, { allowDrop: false, })

Preventing document-level drop

Set preventDocumentDrop to false if you do not want this component to block file drops outside the dropzone.

const service = useMachine(fileUpload.machine, { preventDocumentDrop: false, })

Read-only mode

Set readOnly to prevent adding or removing files.

const service = useMachine(fileUpload.machine, { readOnly: true, })

Allowing directory selection

Set the directory property to true to enable selecting directories instead of files.

This maps to the native input webkitdirectory HTML attribute and allows users to select directories and their contents.

Please note that support for this feature varies from browser to browser.

const service = useMachine(fileUpload.machine, { directory: true, })

Supporting media capture on mobile devices

Set the capture property to specify the media capture mechanism to capture media on the spot. The value can be:

  • user for capturing media from the user-facing camera
  • environment for the outward-facing camera

This behavior only works on mobile devices. On desktop devices, it will open the file system like normal.

const service = useMachine(fileUpload.machine, { capture: "user", })

Pasting files from clipboard

After a user copies an image, to allow pasting the files from the clipboard, you can listen for the paste event and use the api.setFiles method to set the files.

Here's an example of how to do this in React.

function Demo() { const service = useMachine(fileUpload.machine, { accept: "image/*", }) const api = fileUpload.connect(service, normalizeProps) return ( <textarea onPaste={(event) => { if (event.clipboardData?.files) { api.setFiles(Array.from(event.clipboardData.files)) } }} /> ) }

Transforming files before acceptance

Use the transformFiles callback to process files before they're added to acceptedFiles. This is useful for scenarios like image cropping, compression, or format conversion.

The transformFiles function receives the selected files and should return a promise that resolves with the transformed files.

const service = useMachine(fileUpload.machine, { accept: "image/*", transformFiles: async (files) => { return Promise.all( files.map(async (file) => { // Compress or transform the file const transformedBlob = await processImage(file) return new File([transformedBlob], file.name, { type: file.type }) }), ) }, })

While files are being transformed, the api.transforming boolean is true, allowing you to show loading states in your UI.

Customizing accessibility labels

Use translations to customize dropzone and item action labels.

const service = useMachine(fileUpload.machine, { translations: { dropzone: "Drop files here", deleteFile: (file) => `Remove ${file.name}`, }, })

Styling guide

Each part includes a data-part attribute you can target in CSS.

[data-part="root"] { /* styles for root element*/ } [data-part="dropzone"] { /* styles for root element*/ } [data-part="trigger"] { /* styles for file picker trigger */ } [data-part="label"] { /* styles for the input's label */ }

Dragging State

When the user drags a file over the file upload, the data-dragging attribute is added to the root and dropzone parts.

[data-part="root"][data-dragging] { /* styles for when the user is dragging a file over the file upload */ } [data-part="dropzone"][data-dragging] { /* styles for when the user is dragging a file over the file upload */ }

Disabled State

When the file upload is disabled, the data-disabled attribute is added to the component parts.

[data-part="root"][data-disabled] { /* styles for when the file upload is disabled */ } [data-part="dropzone"][data-disabled] { /* styles for when the file upload is disabled */ } [data-part="trigger"][data-disabled] { /* styles for when the file upload is disabled */ } [data-part="label"][data-disabled] { /* styles for when the file upload is disabled */ }

Methods and Properties

Machine Context

The file upload machine exposes the following context properties:

  • namestring | undefinedThe name of the underlying file input
  • idsElementIds | undefinedThe ids of the elements. Useful for composition.
  • translationsIntlTranslations | undefinedThe localized messages to use.
  • acceptRecord<string, string[]> | FileMimeType | FileMimeType[] | undefinedThe accept file types
  • disabledboolean | undefinedWhether the file input is disabled
  • requiredboolean | undefinedWhether the file input is required
  • allowDropboolean | undefinedWhether to allow drag and drop in the dropzone element
  • maxFileSizenumber | undefinedThe maximum file size in bytes
  • minFileSizenumber | undefinedThe minimum file size in bytes
  • maxFilesnumber | undefinedThe maximum number of files
  • preventDocumentDropboolean | undefinedWhether to prevent the drop event on the document
  • validate((file: File, details: FileValidateDetails) => FileError[] | null) | undefinedFunction to validate a file
  • defaultAcceptedFilesFile[] | undefinedThe default accepted files when rendered. Use when you don't need to control the accepted files of the input.
  • acceptedFilesFile[] | undefinedThe controlled accepted files
  • onFileChange((details: FileChangeDetails) => void) | undefinedFunction called when the value changes, whether accepted or rejected
  • onFileAccept((details: FileAcceptDetails) => void) | undefinedFunction called when the file is accepted
  • onFileReject((details: FileRejectDetails) => void) | undefinedFunction called when the file is rejected
  • capture"user" | "environment" | undefinedThe default camera to use when capturing media
  • directoryboolean | undefinedWhether to accept directories, only works in webkit browsers
  • invalidboolean | undefinedWhether the file input is invalid
  • readOnlyboolean | undefinedWhether the file input is read-only
  • transformFiles((files: File[]) => Promise<File[]>) | undefinedFunction to transform the accepted files to apply transformations
  • localestring | undefinedThe current locale. Based on the BCP 47 definition.
  • dir"ltr" | "rtl" | undefinedThe document's text/writing direction.
  • idstringThe unique identifier of the machine.
  • getRootNode(() => ShadowRoot | Document | Node) | undefinedA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.

Machine API

The file upload api exposes the following methods:

  • draggingbooleanWhether the user is dragging something over the root element
  • focusedbooleanWhether the user is focused on the dropzone element
  • disabledbooleanWhether the file input is disabled
  • readOnlybooleanWhether the file input is in read-only mode
  • transformingbooleanWhether files are currently being transformed via `transformFiles`
  • maxFilesReachedbooleanWhether the maximum number of files has been reached
  • remainingFilesnumberThe number of files that can still be added
  • openFilePickerVoidFunctionFunction to open the file dialog
  • deleteFile(file: File, type?: ItemType | undefined) => voidFunction to delete the file from the list
  • acceptedFilesFile[]The accepted files that have been dropped or selected
  • rejectedFilesFileRejection[]The files that have been rejected
  • setFiles(files: File[]) => voidSets the accepted files
  • clearFilesVoidFunctionClears the accepted files
  • clearRejectedFilesVoidFunctionClears the rejected files
  • getFileSize(file: File) => stringReturns the formatted file size (e.g. 1.2MB)
  • createFileUrl(file: File, cb: (url: string) => void) => VoidFunctionReturns the preview url of a file. Returns a function to revoke the url.
  • setClipboardFiles(dt: DataTransfer | null) => booleanSets the clipboard files Returns `true` if the clipboard data contains files, `false` otherwise.

Data Attributes

Root
data-scope
file-upload
data-part
root
data-disabled
Present when disabled
data-readonly
Present when read-only
data-dragging
Present when in the dragging state
Dropzone
data-scope
file-upload
data-part
dropzone
data-invalid
Present when invalid
data-disabled
Present when disabled
data-readonly
Present when read-only
data-dragging
Present when in the dragging state
Trigger
data-scope
file-upload
data-part
trigger
data-disabled
Present when disabled
data-readonly
Present when read-only
data-invalid
Present when invalid
ItemGroup
data-scope
file-upload
data-part
item-group
data-disabled
Present when disabled
data-type
The type of the item
Item
data-scope
file-upload
data-part
item
data-disabled
Present when disabled
data-type
The type of the item
ItemName
data-scope
file-upload
data-part
item-name
data-disabled
Present when disabled
data-type
The type of the item
ItemSizeText
data-scope
file-upload
data-part
item-size-text
data-disabled
Present when disabled
data-type
The type of the item
ItemPreview
data-scope
file-upload
data-part
item-preview
data-disabled
Present when disabled
data-type
The type of the item
ItemPreviewImage
data-scope
file-upload
data-part
item-preview-image
data-disabled
Present when disabled
data-type
The type of the item
ItemDeleteTrigger
data-scope
file-upload
data-part
item-delete-trigger
data-disabled
Present when disabled
data-readonly
Present when read-only
data-type
The type of the item
Label
data-scope
file-upload
data-part
label
data-disabled
Present when disabled
data-required
Present when required
ClearTrigger
data-scope
file-upload
data-part
clear-trigger
data-disabled
Present when disabled
data-readonly
Present when read-only
Edit this page on GitHub

Skip to main content

A file upload component lets users select and manage files.

The native input file element is quite difficult to style and doesn't provide a drag-n-drop version.

The file upload component doesn't handle the actual file uploading process. It only handles the UI and the state of the file upload.

Loading...

Features

  • Supports a button to open the file dialog
  • Supports drag and drop to upload files
  • Set the maximum number of files that can be uploaded
  • Set the maximum size of the files that can be uploaded
  • Set the accepted file types

Installation

Install the file upload package:

npm install @zag-js/file-upload @zag-js/vue # or yarn add @zag-js/file-upload @zag-js/vue

Anatomy

To set up the file upload correctly, you'll need to understand its anatomy and how we name its parts.

Each part includes a data-part attribute to help identify them in the DOM.

Usage

Import the file upload package:

import * as fileUpload from "@zag-js/file-upload"

The file upload package exports two key functions:

  • machine - Behavior logic.
  • connect - Maps behavior to JSX props and event handlers.

Then use the framework integration helpers:

<script setup> import * as fileUpload from "@zag-js/file-upload" import { normalizeProps, useMachine } from "@zag-js/vue" import { computed } from "vue" const service = useMachine(fileUpload.machine, { id: "1" }) const api = computed(() => fileUpload.connect(service, normalizeProps)) </script> <template> <div v-bind="api.getRootProps()"> <div v-bind="api.getDropzoneProps()"> <input v-bind="api.getHiddenInputProps()" /> Drag your files here </div> <button v-bind="api.getTriggerProps()">Choose Files...</button> <ul v-bind="api.getItemGroupProps()"> <li v-for="file in api.acceptedFiles" :key="file.name" v-bind="api.getItemProps({ file })" > <div v-bind="api.getItemNameProps({ file })">{{ file.name }}</div> <button v-bind="api.getItemDeleteTriggerProps({ file })">Delete</button> </li> </ul> </div> </template>

Setting the accepted file types

Use the accept attribute to set the accepted file types.

const service = useMachine(fileUpload.machine, { accept: "image/*", })

Alternatively, you can provide an object with a MIME type and an array of file extensions.

const service = useMachine(fileUpload.machine, { accept: { "image/png": [".png"], "text/html": [".html", ".htm"], }, })

Setting the maximum number of files

Use maxFiles to set how many files can be selected.

const service = useMachine(fileUpload.machine, { maxFiles: 5, })

Setting the minimum size per file

Use minFileSize to reject files smaller than a minimum size.

const service = useMachine(fileUpload.machine, { minFileSize: 1024, // 1KB })

Setting the maximum size per file

Use the maxFileSize attribute to set the maximum size per file that can be uploaded.

const service = useMachine(fileUpload.machine, { maxFileSize: 1024 * 1024 * 10, // 10MB })

Setting initial files

Use defaultAcceptedFiles to prefill the accepted files list.

const service = useMachine(fileUpload.machine, { defaultAcceptedFiles: [ new File(["hello"], "hello.txt", { type: "text/plain" }), ], })

Controlled files

Use acceptedFiles and onFileChange to control accepted files externally.

const service = useMachine(fileUpload.machine, { acceptedFiles, onFileChange(details) { setAcceptedFiles(details.acceptedFiles) }, })

Listening to file changes

When files are uploaded, the onFileChange callback is invoked with the details of the accepted and rejected files.

const service = useMachine(fileUpload.machine, { onFileChange(details) { // details => { acceptedFiles: File[], rejectedFiles: { file: File, errors: FileError[] }[] } console.log(details.acceptedFiles) console.log(details.rejectedFiles) }, })

Listening to accept and reject events

Use onFileAccept and onFileReject for separated success/failure flows.

const service = useMachine(fileUpload.machine, { onFileAccept(details) { console.log("Accepted:", details.files) }, onFileReject(details) { console.log("Rejected:", details.files) }, })

Usage within a form

To use file upload in a form, set name and render api.getHiddenInputProps().

const service = useMachine(fileUpload.machine, { name: "avatar", })
<input {...api.getHiddenInputProps()} />

Displaying image preview

To display a preview of the uploaded image, use the built-in FileReader API to read the file and set the src attribute of an image element.

const service = useMachine(fileUpload.machine, { onFileChange(details) { const reader = new FileReader() reader.onload = (event) => { const image = event.target.result // set the image as the src of an image element } reader.readAsDataURL(details.acceptedFiles[0]) }, })

Applying custom validation

To apply custom validation, set validate to a function that returns an array of error strings.

The returned array can contain any string as an error message. While zagjs supports default errors such as TOO_MANY_FILES, FILE_INVALID_TYPE, FILE_TOO_LARGE, or FILE_TOO_SMALL, you can return any string that represents your custom validation errors.

Return null if no validation errors are detected.

const service = useMachine(fileUpload.machine, { validate(file, details) { // Check if file size exceeds 10MB if (file.size > 1024 * 1024 * 10) { return ["FILE_TOO_LARGE"] } // details => { acceptedFiles, rejectedFiles } console.log(details.acceptedFiles.length) return null }, })

Apply multiple validation errors:

const service = useMachine(fileUpload.machine, { validate(file, details) { const errors = [] // Check file size if (file.size > 10 * 1024 * 1024) { errors.push("FILE_TOO_LARGE") // Default error enum } // Ensure file is a PDF if (!file.name.endsWith(".pdf")) { errors.push("ONLY_PDF_ALLOWED") // Custom error } // Custom check: Reject duplicate files const isDuplicate = details.acceptedFiles.some( (acceptedFile) => acceptedFile.name === file.name, ) if (isDuplicate) { errors.push("FILE_EXISTS") } return errors.length > 0 ? errors : null }, })

Disabling drag and drop

Set allowDrop to false to disable drag and drop.

const service = useMachine(fileUpload.machine, { allowDrop: false, })

Preventing document-level drop

Set preventDocumentDrop to false if you do not want this component to block file drops outside the dropzone.

const service = useMachine(fileUpload.machine, { preventDocumentDrop: false, })

Read-only mode

Set readOnly to prevent adding or removing files.

const service = useMachine(fileUpload.machine, { readOnly: true, })

Allowing directory selection

Set the directory property to true to enable selecting directories instead of files.

This maps to the native input webkitdirectory HTML attribute and allows users to select directories and their contents.

Please note that support for this feature varies from browser to browser.

const service = useMachine(fileUpload.machine, { directory: true, })

Supporting media capture on mobile devices

Set the capture property to specify the media capture mechanism to capture media on the spot. The value can be:

  • user for capturing media from the user-facing camera
  • environment for the outward-facing camera

This behavior only works on mobile devices. On desktop devices, it will open the file system like normal.

const service = useMachine(fileUpload.machine, { capture: "user", })

Pasting files from clipboard

After a user copies an image, to allow pasting the files from the clipboard, you can listen for the paste event and use the api.setFiles method to set the files.

Here's an example of how to do this in React.

function Demo() { const service = useMachine(fileUpload.machine, { accept: "image/*", }) const api = fileUpload.connect(service, normalizeProps) return ( <textarea onPaste={(event) => { if (event.clipboardData?.files) { api.setFiles(Array.from(event.clipboardData.files)) } }} /> ) }

Transforming files before acceptance

Use the transformFiles callback to process files before they're added to acceptedFiles. This is useful for scenarios like image cropping, compression, or format conversion.

The transformFiles function receives the selected files and should return a promise that resolves with the transformed files.

const service = useMachine(fileUpload.machine, { accept: "image/*", transformFiles: async (files) => { return Promise.all( files.map(async (file) => { // Compress or transform the file const transformedBlob = await processImage(file) return new File([transformedBlob], file.name, { type: file.type }) }), ) }, })

While files are being transformed, the api.transforming boolean is true, allowing you to show loading states in your UI.

Customizing accessibility labels

Use translations to customize dropzone and item action labels.

const service = useMachine(fileUpload.machine, { translations: { dropzone: "Drop files here", deleteFile: (file) => `Remove ${file.name}`, }, })

Styling guide

Each part includes a data-part attribute you can target in CSS.

[data-part="root"] { /* styles for root element*/ } [data-part="dropzone"] { /* styles for root element*/ } [data-part="trigger"] { /* styles for file picker trigger */ } [data-part="label"] { /* styles for the input's label */ }

Dragging State

When the user drags a file over the file upload, the data-dragging attribute is added to the root and dropzone parts.

[data-part="root"][data-dragging] { /* styles for when the user is dragging a file over the file upload */ } [data-part="dropzone"][data-dragging] { /* styles for when the user is dragging a file over the file upload */ }

Disabled State

When the file upload is disabled, the data-disabled attribute is added to the component parts.

[data-part="root"][data-disabled] { /* styles for when the file upload is disabled */ } [data-part="dropzone"][data-disabled] { /* styles for when the file upload is disabled */ } [data-part="trigger"][data-disabled] { /* styles for when the file upload is disabled */ } [data-part="label"][data-disabled] { /* styles for when the file upload is disabled */ }

Methods and Properties

Machine Context

The file upload machine exposes the following context properties:

  • namestring | undefinedThe name of the underlying file input
  • idsElementIds | undefinedThe ids of the elements. Useful for composition.
  • translationsIntlTranslations | undefinedThe localized messages to use.
  • acceptRecord<string, string[]> | FileMimeType | FileMimeType[] | undefinedThe accept file types
  • disabledboolean | undefinedWhether the file input is disabled
  • requiredboolean | undefinedWhether the file input is required
  • allowDropboolean | undefinedWhether to allow drag and drop in the dropzone element
  • maxFileSizenumber | undefinedThe maximum file size in bytes
  • minFileSizenumber | undefinedThe minimum file size in bytes
  • maxFilesnumber | undefinedThe maximum number of files
  • preventDocumentDropboolean | undefinedWhether to prevent the drop event on the document
  • validate((file: File, details: FileValidateDetails) => FileError[] | null) | undefinedFunction to validate a file
  • defaultAcceptedFilesFile[] | undefinedThe default accepted files when rendered. Use when you don't need to control the accepted files of the input.
  • acceptedFilesFile[] | undefinedThe controlled accepted files
  • onFileChange((details: FileChangeDetails) => void) | undefinedFunction called when the value changes, whether accepted or rejected
  • onFileAccept((details: FileAcceptDetails) => void) | undefinedFunction called when the file is accepted
  • onFileReject((details: FileRejectDetails) => void) | undefinedFunction called when the file is rejected
  • capture"user" | "environment" | undefinedThe default camera to use when capturing media
  • directoryboolean | undefinedWhether to accept directories, only works in webkit browsers
  • invalidboolean | undefinedWhether the file input is invalid
  • readOnlyboolean | undefinedWhether the file input is read-only
  • transformFiles((files: File[]) => Promise<File[]>) | undefinedFunction to transform the accepted files to apply transformations
  • localestring | undefinedThe current locale. Based on the BCP 47 definition.
  • dir"ltr" | "rtl" | undefinedThe document's text/writing direction.
  • idstringThe unique identifier of the machine.
  • getRootNode(() => ShadowRoot | Document | Node) | undefinedA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.

Machine API

The file upload api exposes the following methods:

  • draggingbooleanWhether the user is dragging something over the root element
  • focusedbooleanWhether the user is focused on the dropzone element
  • disabledbooleanWhether the file input is disabled
  • readOnlybooleanWhether the file input is in read-only mode
  • transformingbooleanWhether files are currently being transformed via `transformFiles`
  • maxFilesReachedbooleanWhether the maximum number of files has been reached
  • remainingFilesnumberThe number of files that can still be added
  • openFilePickerVoidFunctionFunction to open the file dialog
  • deleteFile(file: File, type?: ItemType | undefined) => voidFunction to delete the file from the list
  • acceptedFilesFile[]The accepted files that have been dropped or selected
  • rejectedFilesFileRejection[]The files that have been rejected
  • setFiles(files: File[]) => voidSets the accepted files
  • clearFilesVoidFunctionClears the accepted files
  • clearRejectedFilesVoidFunctionClears the rejected files
  • getFileSize(file: File) => stringReturns the formatted file size (e.g. 1.2MB)
  • createFileUrl(file: File, cb: (url: string) => void) => VoidFunctionReturns the preview url of a file. Returns a function to revoke the url.
  • setClipboardFiles(dt: DataTransfer | null) => booleanSets the clipboard files Returns `true` if the clipboard data contains files, `false` otherwise.

Data Attributes

Root
data-scope
file-upload
data-part
root
data-disabled
Present when disabled
data-readonly
Present when read-only
data-dragging
Present when in the dragging state
Dropzone
data-scope
file-upload
data-part
dropzone
data-invalid
Present when invalid
data-disabled
Present when disabled
data-readonly
Present when read-only
data-dragging
Present when in the dragging state
Trigger
data-scope
file-upload
data-part
trigger
data-disabled
Present when disabled
data-readonly
Present when read-only
data-invalid
Present when invalid
ItemGroup
data-scope
file-upload
data-part
item-group
data-disabled
Present when disabled
data-type
The type of the item
Item
data-scope
file-upload
data-part
item
data-disabled
Present when disabled
data-type
The type of the item
ItemName
data-scope
file-upload
data-part
item-name
data-disabled
Present when disabled
data-type
The type of the item
ItemSizeText
data-scope
file-upload
data-part
item-size-text
data-disabled
Present when disabled
data-type
The type of the item
ItemPreview
data-scope
file-upload
data-part
item-preview
data-disabled
Present when disabled
data-type
The type of the item
ItemPreviewImage
data-scope
file-upload
data-part
item-preview-image
data-disabled
Present when disabled
data-type
The type of the item
ItemDeleteTrigger
data-scope
file-upload
data-part
item-delete-trigger
data-disabled
Present when disabled
data-readonly
Present when read-only
data-type
The type of the item
Label
data-scope
file-upload
data-part
label
data-disabled
Present when disabled
data-required
Present when required
ClearTrigger
data-scope
file-upload
data-part
clear-trigger
data-disabled
Present when disabled
data-readonly
Present when read-only
Edit this page on GitHub

Skip to main content

A file upload component lets users select and manage files.

The native input file element is quite difficult to style and doesn't provide a drag-n-drop version.

The file upload component doesn't handle the actual file uploading process. It only handles the UI and the state of the file upload.

Loading...

Features

  • Supports a button to open the file dialog
  • Supports drag and drop to upload files
  • Set the maximum number of files that can be uploaded
  • Set the maximum size of the files that can be uploaded
  • Set the accepted file types

Installation

Install the file upload package:

npm install @zag-js/file-upload @zag-js/react # or yarn add @zag-js/file-upload @zag-js/react

Anatomy

To set up the file upload correctly, you'll need to understand its anatomy and how we name its parts.

Each part includes a data-part attribute to help identify them in the DOM.

Usage

Import the file upload package:

import * as fileUpload from "@zag-js/file-upload"

The file upload package exports two key functions:

  • machine - Behavior logic.
  • connect - Maps behavior to JSX props and event handlers.

Then use the framework integration helpers:

import * as fileUpload from "@zag-js/file-upload" import { normalizeProps, useMachine } from "@zag-js/react" import { useId } from "react" export function FileUpload() { const service = useMachine(fileUpload.machine, { id: useId(), }) const api = fileUpload.connect(service, normalizeProps) return ( <div {...api.getRootProps()}> <div {...api.getDropzoneProps()}> <input {...api.getHiddenInputProps()} /> <span>Drag your file(s) here</span> </div> <button {...api.getTriggerProps()}>Choose file(s)</button> <ul {...api.getItemGroupProps()}> {api.acceptedFiles.map((file) => ( <li key={file.name} {...api.getItemProps({ file })}> <div {...api.getItemNameProps({ file })}>{file.name}</div> <button {...api.getItemDeleteTriggerProps({ file })}>Delete</button> </li> ))} </ul> </div> ) }

Setting the accepted file types

Use the accept attribute to set the accepted file types.

const service = useMachine(fileUpload.machine, { accept: "image/*", })

Alternatively, you can provide an object with a MIME type and an array of file extensions.

const service = useMachine(fileUpload.machine, { accept: { "image/png": [".png"], "text/html": [".html", ".htm"], }, })

Setting the maximum number of files

Use maxFiles to set how many files can be selected.

const service = useMachine(fileUpload.machine, { maxFiles: 5, })

Setting the minimum size per file

Use minFileSize to reject files smaller than a minimum size.

const service = useMachine(fileUpload.machine, { minFileSize: 1024, // 1KB })

Setting the maximum size per file

Use the maxFileSize attribute to set the maximum size per file that can be uploaded.

const service = useMachine(fileUpload.machine, { maxFileSize: 1024 * 1024 * 10, // 10MB })

Setting initial files

Use defaultAcceptedFiles to prefill the accepted files list.

const service = useMachine(fileUpload.machine, { defaultAcceptedFiles: [ new File(["hello"], "hello.txt", { type: "text/plain" }), ], })

Controlled files

Use acceptedFiles and onFileChange to control accepted files externally.

const service = useMachine(fileUpload.machine, { acceptedFiles, onFileChange(details) { setAcceptedFiles(details.acceptedFiles) }, })

Listening to file changes

When files are uploaded, the onFileChange callback is invoked with the details of the accepted and rejected files.

const service = useMachine(fileUpload.machine, { onFileChange(details) { // details => { acceptedFiles: File[], rejectedFiles: { file: File, errors: FileError[] }[] } console.log(details.acceptedFiles) console.log(details.rejectedFiles) }, })

Listening to accept and reject events

Use onFileAccept and onFileReject for separated success/failure flows.

const service = useMachine(fileUpload.machine, { onFileAccept(details) { console.log("Accepted:", details.files) }, onFileReject(details) { console.log("Rejected:", details.files) }, })

Usage within a form

To use file upload in a form, set name and render api.getHiddenInputProps().

const service = useMachine(fileUpload.machine, { name: "avatar", })
<input {...api.getHiddenInputProps()} />

Displaying image preview

To display a preview of the uploaded image, use the built-in FileReader API to read the file and set the src attribute of an image element.

const service = useMachine(fileUpload.machine, { onFileChange(details) { const reader = new FileReader() reader.onload = (event) => { const image = event.target.result // set the image as the src of an image element } reader.readAsDataURL(details.acceptedFiles[0]) }, })

Applying custom validation

To apply custom validation, set validate to a function that returns an array of error strings.

The returned array can contain any string as an error message. While zagjs supports default errors such as TOO_MANY_FILES, FILE_INVALID_TYPE, FILE_TOO_LARGE, or FILE_TOO_SMALL, you can return any string that represents your custom validation errors.

Return null if no validation errors are detected.

const service = useMachine(fileUpload.machine, { validate(file, details) { // Check if file size exceeds 10MB if (file.size > 1024 * 1024 * 10) { return ["FILE_TOO_LARGE"] } // details => { acceptedFiles, rejectedFiles } console.log(details.acceptedFiles.length) return null }, })

Apply multiple validation errors:

const service = useMachine(fileUpload.machine, { validate(file, details) { const errors = [] // Check file size if (file.size > 10 * 1024 * 1024) { errors.push("FILE_TOO_LARGE") // Default error enum } // Ensure file is a PDF if (!file.name.endsWith(".pdf")) { errors.push("ONLY_PDF_ALLOWED") // Custom error } // Custom check: Reject duplicate files const isDuplicate = details.acceptedFiles.some( (acceptedFile) => acceptedFile.name === file.name, ) if (isDuplicate) { errors.push("FILE_EXISTS") } return errors.length > 0 ? errors : null }, })

Disabling drag and drop

Set allowDrop to false to disable drag and drop.

const service = useMachine(fileUpload.machine, { allowDrop: false, })

Preventing document-level drop

Set preventDocumentDrop to false if you do not want this component to block file drops outside the dropzone.

const service = useMachine(fileUpload.machine, { preventDocumentDrop: false, })

Read-only mode

Set readOnly to prevent adding or removing files.

const service = useMachine(fileUpload.machine, { readOnly: true, })

Allowing directory selection

Set the directory property to true to enable selecting directories instead of files.

This maps to the native input webkitdirectory HTML attribute and allows users to select directories and their contents.

Please note that support for this feature varies from browser to browser.

const service = useMachine(fileUpload.machine, { directory: true, })

Supporting media capture on mobile devices

Set the capture property to specify the media capture mechanism to capture media on the spot. The value can be:

  • user for capturing media from the user-facing camera
  • environment for the outward-facing camera

This behavior only works on mobile devices. On desktop devices, it will open the file system like normal.

const service = useMachine(fileUpload.machine, { capture: "user", })

Pasting files from clipboard

After a user copies an image, to allow pasting the files from the clipboard, you can listen for the paste event and use the api.setFiles method to set the files.

Here's an example of how to do this in React.

function Demo() { const service = useMachine(fileUpload.machine, { accept: "image/*", }) const api = fileUpload.connect(service, normalizeProps) return ( <textarea onPaste={(event) => { if (event.clipboardData?.files) { api.setFiles(Array.from(event.clipboardData.files)) } }} /> ) }

Transforming files before acceptance

Use the transformFiles callback to process files before they're added to acceptedFiles. This is useful for scenarios like image cropping, compression, or format conversion.

The transformFiles function receives the selected files and should return a promise that resolves with the transformed files.

const service = useMachine(fileUpload.machine, { accept: "image/*", transformFiles: async (files) => { return Promise.all( files.map(async (file) => { // Compress or transform the file const transformedBlob = await processImage(file) return new File([transformedBlob], file.name, { type: file.type }) }), ) }, })

While files are being transformed, the api.transforming boolean is true, allowing you to show loading states in your UI.

Customizing accessibility labels

Use translations to customize dropzone and item action labels.

const service = useMachine(fileUpload.machine, { translations: { dropzone: "Drop files here", deleteFile: (file) => `Remove ${file.name}`, }, })

Styling guide

Each part includes a data-part attribute you can target in CSS.

[data-part="root"] { /* styles for root element*/ } [data-part="dropzone"] { /* styles for root element*/ } [data-part="trigger"] { /* styles for file picker trigger */ } [data-part="label"] { /* styles for the input's label */ }

Dragging State

When the user drags a file over the file upload, the data-dragging attribute is added to the root and dropzone parts.

[data-part="root"][data-dragging] { /* styles for when the user is dragging a file over the file upload */ } [data-part="dropzone"][data-dragging] { /* styles for when the user is dragging a file over the file upload */ }

Disabled State

When the file upload is disabled, the data-disabled attribute is added to the component parts.

[data-part="root"][data-disabled] { /* styles for when the file upload is disabled */ } [data-part="dropzone"][data-disabled] { /* styles for when the file upload is disabled */ } [data-part="trigger"][data-disabled] { /* styles for when the file upload is disabled */ } [data-part="label"][data-disabled] { /* styles for when the file upload is disabled */ }

Methods and Properties

Machine Context

The file upload machine exposes the following context properties:

  • namestring | undefinedThe name of the underlying file input
  • idsElementIds | undefinedThe ids of the elements. Useful for composition.
  • translationsIntlTranslations | undefinedThe localized messages to use.
  • acceptRecord<string, string[]> | FileMimeType | FileMimeType[] | undefinedThe accept file types
  • disabledboolean | undefinedWhether the file input is disabled
  • requiredboolean | undefinedWhether the file input is required
  • allowDropboolean | undefinedWhether to allow drag and drop in the dropzone element
  • maxFileSizenumber | undefinedThe maximum file size in bytes
  • minFileSizenumber | undefinedThe minimum file size in bytes
  • maxFilesnumber | undefinedThe maximum number of files
  • preventDocumentDropboolean | undefinedWhether to prevent the drop event on the document
  • validate((file: File, details: FileValidateDetails) => FileError[] | null) | undefinedFunction to validate a file
  • defaultAcceptedFilesFile[] | undefinedThe default accepted files when rendered. Use when you don't need to control the accepted files of the input.
  • acceptedFilesFile[] | undefinedThe controlled accepted files
  • onFileChange((details: FileChangeDetails) => void) | undefinedFunction called when the value changes, whether accepted or rejected
  • onFileAccept((details: FileAcceptDetails) => void) | undefinedFunction called when the file is accepted
  • onFileReject((details: FileRejectDetails) => void) | undefinedFunction called when the file is rejected
  • capture"user" | "environment" | undefinedThe default camera to use when capturing media
  • directoryboolean | undefinedWhether to accept directories, only works in webkit browsers
  • invalidboolean | undefinedWhether the file input is invalid
  • readOnlyboolean | undefinedWhether the file input is read-only
  • transformFiles((files: File[]) => Promise<File[]>) | undefinedFunction to transform the accepted files to apply transformations
  • localestring | undefinedThe current locale. Based on the BCP 47 definition.
  • dir"ltr" | "rtl" | undefinedThe document's text/writing direction.
  • idstringThe unique identifier of the machine.
  • getRootNode(() => ShadowRoot | Document | Node) | undefinedA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.

Machine API

The file upload api exposes the following methods:

  • draggingbooleanWhether the user is dragging something over the root element
  • focusedbooleanWhether the user is focused on the dropzone element
  • disabledbooleanWhether the file input is disabled
  • readOnlybooleanWhether the file input is in read-only mode
  • transformingbooleanWhether files are currently being transformed via `transformFiles`
  • maxFilesReachedbooleanWhether the maximum number of files has been reached
  • remainingFilesnumberThe number of files that can still be added
  • openFilePickerVoidFunctionFunction to open the file dialog
  • deleteFile(file: File, type?: ItemType | undefined) => voidFunction to delete the file from the list
  • acceptedFilesFile[]The accepted files that have been dropped or selected
  • rejectedFilesFileRejection[]The files that have been rejected
  • setFiles(files: File[]) => voidSets the accepted files
  • clearFilesVoidFunctionClears the accepted files
  • clearRejectedFilesVoidFunctionClears the rejected files
  • getFileSize(file: File) => stringReturns the formatted file size (e.g. 1.2MB)
  • createFileUrl(file: File, cb: (url: string) => void) => VoidFunctionReturns the preview url of a file. Returns a function to revoke the url.
  • setClipboardFiles(dt: DataTransfer | null) => booleanSets the clipboard files Returns `true` if the clipboard data contains files, `false` otherwise.

Data Attributes

Root
data-scope
file-upload
data-part
root
data-disabled
Present when disabled
data-readonly
Present when read-only
data-dragging
Present when in the dragging state
Dropzone
data-scope
file-upload
data-part
dropzone
data-invalid
Present when invalid
data-disabled
Present when disabled
data-readonly
Present when read-only
data-dragging
Present when in the dragging state
Trigger
data-scope
file-upload
data-part
trigger
data-disabled
Present when disabled
data-readonly
Present when read-only
data-invalid
Present when invalid
ItemGroup
data-scope
file-upload
data-part
item-group
data-disabled
Present when disabled
data-type
The type of the item
Item
data-scope
file-upload
data-part
item
data-disabled
Present when disabled
data-type
The type of the item
ItemName
data-scope
file-upload
data-part
item-name
data-disabled
Present when disabled
data-type
The type of the item
ItemSizeText
data-scope
file-upload
data-part
item-size-text
data-disabled
Present when disabled
data-type
The type of the item
ItemPreview
data-scope
file-upload
data-part
item-preview
data-disabled
Present when disabled
data-type
The type of the item
ItemPreviewImage
data-scope
file-upload
data-part
item-preview-image
data-disabled
Present when disabled
data-type
The type of the item
ItemDeleteTrigger
data-scope
file-upload
data-part
item-delete-trigger
data-disabled
Present when disabled
data-readonly
Present when read-only
data-type
The type of the item
Label
data-scope
file-upload
data-part
label
data-disabled
Present when disabled
data-required
Present when required
ClearTrigger
data-scope
file-upload
data-part
clear-trigger
data-disabled
Present when disabled
data-readonly
Present when read-only
Edit this page on GitHub